Main Page Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members File Members Related Pages

# CDR.h File Reference

`#include "ace/pre.h"`
`#include "tao/corbafwd.h"`
`#include "ace/CDR_Stream.h"`
`#include "ace/post.h"`

Include dependency graph for CDR.h:

This graph shows which files directly or indirectly include this file:

## Compounds
class | TAO_InputCDR
class | TAO_OutputCDR
## Functions
TAO_Export CORBA::Boolean | operator<< (TAO_OutputCDR &os, CORBA::Short x)
TAO_Export CORBA::Boolean | operator<< (TAO_OutputCDR &os, CORBA::UShort x)
TAO_Export CORBA::Boolean | operator<< (TAO_OutputCDR &os, CORBA::Long x)
TAO_Export CORBA::Boolean | operator<< (TAO_OutputCDR &os, CORBA::ULong x)
TAO_Export CORBA::Boolean | operator<< (TAO_OutputCDR &os, CORBA::Float x)
TAO_Export CORBA::Boolean | operator<< (TAO_OutputCDR &os, CORBA::Double x)
TAO_Export CORBA::Boolean | operator<< (TAO_OutputCDR &os, const CORBA::Char* x)
TAO_Export CORBA::Boolean | operator<< (TAO_OutputCDR &os, const CORBA::WChar* x)
TAO_Export CORBA::Boolean | operator>> (TAO_InputCDR &is, CORBA::Short &x)
TAO_Export CORBA::Boolean | operator>> (TAO_InputCDR &is, CORBA::UShort &x)
TAO_Export CORBA::Boolean | operator>> (TAO_InputCDR &is, CORBA::Long &x)
TAO_Export CORBA::Boolean | operator>> (TAO_InputCDR &is, CORBA::ULong &x)
TAO_Export CORBA::Boolean | operator>> (TAO_InputCDR &is, CORBA::LongLong &x)
TAO_Export CORBA::Boolean | operator>> (TAO_InputCDR &is, CORBA::ULongLong &x)
TAO_Export CORBA::Boolean | operator>> (TAO_InputCDR &is, CORBA::LongDouble &x)
TAO_Export CORBA::Boolean | operator>> (TAO_InputCDR &is, CORBA::Float &x)
TAO_Export CORBA::Boolean | operator>> (TAO_InputCDR &is, CORBA::Double &x)
TAO_Export CORBA::Boolean | operator>> (TAO_InputCDR &is, CORBA::Char* &x)
TAO_Export CORBA::Boolean | operator>> (TAO_InputCDR &is, CORBA::WChar* &x)
TAO_Export CORBA::Boolean | operator<< (TAO_OutputCDR &, const CORBA::ParameterMode &)
TAO_Export CORBA::Boolean | operator>> (TAO_InputCDR &, CORBA::ParameterMode &)

## Detailed Description

CDR.h,v 1.65 2001/08/09 16:47:48 bala Exp

Common Data Representation (CDR) marshaling streams.

This implementation assumes that the native numeric representation is two's complement for integers, IEEE single/double for floats. Also that characters are in ISO Latin/1.

Note that CDR itself makes no such assumptions, but this implementation makes such assumptions for reasons of efficiency. Careful enhancements could preserve that efficiency where the assumptions are true, yet still allow the code to work when they aren't true.

The implementation expects that buffers are aligned according to the strongest CDR alignment restriction.

NOTE: this does everything "CDR 1.1" does ... that is, it supports the five extended OMG-IDL data types in UNO Appendix A, which provide richer arithmetic types (64 bit integers, "quad precision" FP) and UNICODE-based characters and strings. Those types are not standard parts of OMG-IDL at this time.

THREADING NOTE: CDR data structures must be protected against concurrent access by their owning thread.

Author(s):
  Copyright 1994-1995 by Sun Microsystems , Inc. Many enhancements added by Aniruddha Gokhale and Carlos O'Ryan.

## Function Documentation

ACE_INLINE CORBA::Boolean operator<< ( | TAO_OutputCDR & strm,
| const CORBA::ParameterMode & _tao_enumval )

ACE_INLINE CORBA::Boolean operator<< ( | TAO_OutputCDR & os,
| const CORBA::WChar * x )

ACE_INLINE CORBA::Boolean operator<< ( | TAO_OutputCDR & os,
| const CORBA::Char * x )

TAO_Export CORBA::Boolean operator<< ( | TAO_OutputCDR & os,
| CORBA::Double x )

TAO_Export CORBA::Boolean operator<< ( | TAO_OutputCDR & os,
| CORBA::Float x )

ACE_INLINE CORBA::Boolean operator<< ( | TAO_OutputCDR & os,
| CORBA::ULong x )

ACE_INLINE CORBA::Boolean operator<< ( | TAO_OutputCDR & os,
| CORBA::Long x )

ACE_INLINE CORBA::Boolean operator<< ( | TAO_OutputCDR & os,
| CORBA::UShort x )

CORBA::Boolean operator<< ( | TAO_OutputCDR & strm,
| CORBA:: Policy_ptr )

ACE_INLINE CORBA::Boolean operator>> ( | TAO_InputCDR & strm,
| CORBA::ParameterMode & _tao_enumval )

ACE_INLINE CORBA::Boolean operator>> ( | TAO_InputCDR & is,
| CORBA::WChar *& x )

ACE_INLINE CORBA::Boolean operator>> ( | TAO_InputCDR & is,
| CORBA::Char *& x )

ACE_INLINE CORBA::Boolean operator>> ( | TAO_InputCDR & is,
| CORBA::Double & x )

ACE_INLINE CORBA::Boolean operator>> ( | TAO_InputCDR & is,
| CORBA::Float & x )

ACE_INLINE CORBA::Boolean operator>> ( | TAO_InputCDR & is,
| CORBA::LongDouble & x )

ACE_INLINE CORBA::Boolean operator>> ( | TAO_InputCDR & is,
| CORBA::ULongLong & x )

ACE_INLINE CORBA::Boolean operator>> ( | TAO_InputCDR & is,
| CORBA::LongLong & x )

ACE_INLINE CORBA::Boolean operator>> ( | TAO_InputCDR & is,
| CORBA::ULong & x )

ACE_INLINE CORBA::Boolean operator>> ( | TAO_InputCDR & is,
| CORBA::Long & x )

ACE_INLINE CORBA::Boolean operator>> ( | TAO_InputCDR & is,
| CORBA::UShort & x )

ACE_INLINE CORBA::Boolean operator>> ( | TAO_InputCDR & is,
| CORBA::Short & x )